"use strict";
(function ($) {
	var
	// Will contain the last events' string and element, used for comparison
			selObj = {str: "", el: undefined},
	// Cache selection range methods
			docSel = document.selection,
			winSel = window.getSelection && window.getSelection(),
	// Events to be bound for our handler
			bindEvents = ['mouseup', 'keyup'],
	// Helper to grab currently selected text
			getSelected = function (evt) {
				// If the called event originates from a inputbox/form element (in FF), use that
				// to get the selected text (FF doesn't trigger getSelection() on input
				// elements natively)
				var el = $( evt.originalEvent.target ).is( ':input' ) ?
						evt.originalEvent.target :
						undefined;

				return el && +el.selectionEnd ?
						$( el ).val().substring( el.selectionStart, el.selectionEnd ) :
						(winSel || docSel.createRange().text || "").toString();
			},
	// Helper to grab which common ancestor the text has
			getOrigin = function (input) {
				return docSel && docSel.createRange().parentElement()
						|| input
						|| winSel && winSel.rangeCount > 0 && winSel.getRangeAt( 0 ).commonAncestorContainer
						|| document.body;
			},
	// Create our custom event namespace
			$me = $.event.special.textselect = {
				// Do stuff when it is bound
				setup: function () {
					var that = this;
					// Hook mouseup to fire our custom event
					$( bindEvents ).each(
						function (i, o) {
							$( that ).bind( o, $me.handler );
						}
					);
				},
				// Do stuff when it is unbound
				teardown: function () {
					var that = this;
					$( bindEvents ).each(
						function (i, o) {
							$( that ).unbind( o, $me.handler );
						}
					);
				},
				// Do stuff when the event is triggered
				handler: function (evt) {
					// Since we're not letting jQuery handle this object (due to our return
					// parameters, we "fix" the event object to be cross-browser compliant
					// manually
					evt = $.event.fix( evt );

					// console.log(evt.originalEvent.target);
					// Grab currently selected text and its common ancestor element
					var
							curText    = getSelected( evt ),
							conElement = $( evt.originalEvent.target ).is( ':input' ) ?
							getOrigin( evt.originalEvent.target ) :
							getOrigin();
					if (conElement.nodeType === 3) {
						conElement = conElement.parentNode;
					}
					// If it differs from the old selected text, trigger event
					if (selObj.str !== curText || selObj.el !== conElement) {
						// Set currently selected text (and element) to the actual currently
						// selected text and element
						selObj = {str: curText, el: conElement};
						// Change event type to our custom event
						evt.type = 'textselect';
						// Fire the simulated event
						$.event.trigger( evt, [selObj.str, selObj.el] );
					}
				}
	};
})( jQuery );

jQuery( document ).ready(
	function(){(function($){
		esas_share_link_change();
		// On select text
		jQuery( document ).bind(
			'textselect',
			function (evt, string, element) {
				if (string !== null && string !== '' && string.length > 10) {
					// string = here string is selected content

					// unbind click on social shares in popup

					jQuery( '.shareit a' ).each(
						function () {
							jQuery( this ).unbind( "click" );
						}
					);
					// Get shareparent_element object (Get main content div)
					if (jQuery( element ).hasClass( 'asas_shareit' )) {
						var shareparent_element = jQuery( element );
					} else {
						var shareparent_element = jQuery( element ).closest( '.asas_shareit' );
					}
					var share_content = window.getSelection().toString();
					jQuery('.asas_share_btn').each(function() {
						var rev = jQuery(this).attr('rev');
						var title = jQuery(this).attr('title');
						let params = new URLSearchParams(rev);
						if( 'Twitter' == title ) {
							params.set('text', share_content);
						}
						if( 'LinkedIn' == title ) {
							params.set('summary', share_content);
						}
						if( 'Facebook' == title ) {
							params.set('quote', share_content);
						}						
						jQuery(this).attr('rev', decodeURIComponent(params.toString()));
					});
					// Social share will work if selected text length > 10
					if (string !== "" && string.length > 10) {
						if (sasoptnObj.asas_widget_in_popup == 'beside_selected_text' || sasoptnObj.asas_widget_in_popup == 'in_popup') {
							if (jQuery( '.shareit' ).length) {
								if ( ! jQuery( '.asas_shareit_be' ).length) {
									var asas_be_element       = document.createElement( 'div' );   // make box
									var asas_shareit_ele      = jQuery( '.shareit' ).html();
									var asas_be_class         = 'asas_shareit_be ';
									asas_be_class            += jQuery( '.shareit' ).attr( 'class' );
									asas_be_element.className = asas_be_class;
									asas_be_element.innerHTML = asas_shareit_ele;
									document.body.appendChild( asas_be_element );
								}
								var range             = window.getSelection().getRangeAt( 0 );
								var rect              = range.getBoundingClientRect();
								var asas_select_width = rect.width;
								var box_width         = jQuery( '.asas_shareit_be' ).width();
								var box_height        = jQuery( '.asas_shareit_be' ).outerHeight( true );
								var asas_select_left  = 0;
								if (box_width >= asas_select_width) {
									var final_width  = box_width - asas_select_width;
									asas_select_left = rect.left - (final_width / 2);
								} else {
									var final_width  = rect.width - box_width;
									asas_select_left = rect.left + (final_width / 2);
								}
								if (asas_select_left < 0) {
									asas_select_left = 0;
								}
								var asas_select_top = evt.pageY + 15;
								var total_top       = asas_select_top + box_height;
								if (jQuery( document ).height() < total_top) {
									var minus_height = total_top - jQuery( document ).height();
									asas_select_top  = asas_select_top - minus_height - 5;
								}
								var o = {
									left: asas_select_left,
									top: asas_select_top
								};
								jQuery( '.asas_shareit_be' ).offset( o );
								jQuery( '.asas_shareit_be' ).css( 'display', 'inline-block' );
								var window_width  = jQuery( window ).width();
								var box_max_width = window_width - asas_select_left;
								jQuery( '.asas_shareit_be' ).css( 'max-width',box_max_width );
								if (sasoptnObj.asas_widget_in_popup == 'in_popup') {
									jQuery( 'body' ).append( '<div class="sas-share-it-overlay"></div>' );
								}
							}
						}
						setTimeout(
							function () {
								var mask_width = Math.max.apply(
									null,
									jQuery( '.share-icon-wrapper' ).find( jQuery( '.share-icon-item div' ) ).map(
										function () {
											return jQuery( this ).width();
										}
									).get()
								);
								if (jQuery( '.share-icon-wrapper' ).hasClass( 'asas_icon_left' ) || jQuery( '.share-icon-wrapper' ).hasClass( 'asas_icon_right' )) {
									mask_width = mask_width;
								} else {
									mask_width = mask_width;
								}

								jQuery( '.share-icon-item div' ).css( 'min-width', mask_width );
							},
							500
						);
					} else {
						if (sasoptnObj.asas_widget_in_popup == 'in_popup' || sasoptnObj.asas_widget_in_popup == 'beside_selected_text') {
							jQuery( '.shareit' ).hide();
							jQuery( '.share-note' ).hide();
							jQuery( '.sas-share-it-overlay' ).remove();
							jQuery( '.asas_shareit_be' ).remove();
						}
					}
					if (sasoptnObj.asas_widget_in_popup == 'in_popup' || sasoptnObj.asas_widget_in_popup == 'beside_selected_text') {
						esas_inline_share_link_change( string,shareparent_element );
					} else {
						esas_share_link_change( string );
					}
					jQuery( '.popup-close-btn' ).on(
						'click',
						function () {
							jQuery( '.asas_shareit_be' ).remove();
							jQuery( '.shareit' ).hide();
							jQuery( '.sas-share-it-overlay' ).remove();
						}
					);
				}
			}
		);
		jQuery( document ).on(
			'click',
			'.sas-inline-share-text',
			function (e) {
				var string = jQuery( this ).text();
				if (string == "" && string.length < 10) {
					jQuery( '.shareit_by_class' ).css( 'display', 'none' );
					jQuery( '.shareit_by_class' ).hide();
					jQuery( '.sas-share-it-overlay' ).remove();
				}
				if (string !== "" && string.length > 10) {
					jQuery( '.shareit_by_class' ).css( 'display', 'inline-block' );
					if (jQuery( '.shareit_by_class' ).length) {
						var range             = window.getSelection().getRangeAt( 0 );
						var rect              = range.getBoundingClientRect();
						var asas_select_width = rect.width;
						var box_width         = jQuery( '.shareit_by_class' ).width();
						var box_height        = jQuery( '.shareit_by_class' ).outerHeight( true );
						var asas_select_left  = 0;
						if (box_width >= asas_select_width) {
							var final_width  = box_width - asas_select_width;
							asas_select_left = rect.left - (final_width / 2);
						} else {
							var final_width  = rect.width - box_width;
							asas_select_left = rect.left + (final_width / 2);
						}
						if (asas_select_left < 0) {
							asas_select_left = 0;
						}
						var asas_select_top = e.pageY + 15;
						var total_top       = asas_select_top + box_height;
						if (jQuery( document ).height() < total_top) {
							var minus_height = total_top - jQuery( document ).height();
							asas_select_top  = asas_select_top - minus_height - 5;
						}
						var o = {
							left: asas_select_left,
							top: asas_select_top
						};
						jQuery( '.shareit_by_class' ).offset( o );
						jQuery( '.shareit_by_class' ).css( 'display', 'inline-block' );
						var window_width  = jQuery( window ).width();
						var box_max_width = window_width - asas_select_left;
						jQuery( '.shareit_by_class' ).css( 'max-width',box_max_width );
						if (sasoptnObj.asas_widget_in_popup == 'in_popup') {
							jQuery( 'body' ).append( '<div class="sas-share-it-overlay"></div>' );
						}
						var shareparent_element = jQuery( '.shareit_by_class' );
						esas_inline_share_link_change( string,shareparent_element );
					}
				}
			}
		);
		jQuery( '.shareit_by_class .popup-close-btn-by-class' ).on(
			'click',
			function () {
				jQuery( '.shareit_by_class' ).css( 'display', 'none' );
				jQuery( '.shareit_by_class' ).hide();
				jQuery( '.sas-share-it-overlay' ).remove();
			}
		);

	}(jQuery))
	}
);
function esas_inline_share_link_change(string, shareparent_element) {
	jQuery( '.share-icon-wrapper a' ).each(
		function () {
			jQuery( document ).on(
				'click',
				'.share-icon-wrapper a',
				function (event) {
					event.stopPropagation();
					event.stopImmediatePropagation();
					var social_media  = jQuery( this ).attr( "title" );
					var post_id       = jQuery( '[name="post_id"]' ).val();
					var post_type     = jQuery( '[name="post_type"]' ).val();
					var link          = jQuery( this ).attr( "rev" );
					var share_content = window.getSelection().toString();
					link              = link.replace( /{excerpt}/g, encodeURIComponent( share_content ) );
					link              = link.replace( /{de-excerpt}/g, encodeURIComponent( share_content ) );
					link              = link.replace( /{text}/g, encodeURIComponent( share_content ) );
					jQuery.ajax(
						{
							type   : "POST",
							url : ajaxurl,
							data   : {
								'share_content': share_content,
								'social_media': social_media,
								'post_id': post_id,
								'post_type': post_type,
								action: 'submit_asas_log',
								esas_front_nonce : esasObj.esas_front_nonce,
							},
							success: function(response){
								jQuery( '[name="share_content"]' ).val( share_content );
								jQuery( '[name="social_media"]' ).val( social_media );
							}
						}
					);
					if (link.indexOf( 'mailto' ) <= 0) {
						window.open( link, '_blank' );
					}
					jQuery( shareparent_element ).find( '.shareit' ).css( 'display', 'none' );
					jQuery( '.shareit_by_class' ).hide();
					jQuery( '.sas-share-it-overlay' ).remove();
					jQuery( '.asas_shareit_be' ).remove();
				}
			);
		}
	);
}
function esas_share_link_change(string) {
	if (sasoptnObj.asas_widget_in_popup != 'in_popup' && sasoptnObj.asas_widget_in_popup != 'beside_selected_text') {
		jQuery( '.shareit' ).find( '.share-icon-wrapper a' ).each(
			function () {
				jQuery( document ).on(
					'click',
					'.share-icon-wrapper a',
					function (event) {
						event.stopPropagation();
						event.stopImmediatePropagation();
						var social_media  = jQuery( this ).attr( "title" );
						var post_id       = jQuery( '[name="post_id"]' ).val();
						var post_type     = jQuery( '[name="post_type"]' ).val();
						var link          = jQuery( this ).attr( "rev" );
						var share_content = '';
						if (string !== "") {
							share_content = window.getSelection().toString();
						}
						jQuery.ajax(
							{
								type   : "POST",
								url : ajaxurl,
								data   : {
									'share_content': share_content,
									'social_media': social_media,
									'post_id': post_id,
									'post_type': post_type,
									action: 'submit_asas_log',
									esas_front_nonce : esasObj.esas_front_nonce,
								},
								success: function(response){
									jQuery( '[name="share_content"]' ).val( share_content );
									jQuery( '[name="social_media"]' ).val( social_media );
								}
							}
						);
						link = link.replace( /{excerpt}/g, encodeURIComponent( share_content ) );
						link = link.replace( /{de-excerpt}/g, encodeURIComponent( share_content ) );
						link = link.replace( /{text}/g, encodeURIComponent( share_content ) );
						jQuery( this ).attr( 'href', link );
						if (link.indexOf( 'mailto' ) <= 0) {
							jQuery( this ).attr( 'target', '_blank' );
						}
					}
				);
			}
		);
	}
}
