<?php
/**
 * Plugin Name: Easy Select and Share
 * Plugin URI: https://www.solwininfotech.com/product/wordpress-plugins/easy-select-and-share/
 * Description: Share your selected Post content to social networks instantly.
 * Author: Solwin infotech
 * Author URI: https://www.solwininfotech.com/
 * Copyright: Solwin Infotech
 * Version: 1.1
 * Requires at least: 5.0
 * Tested up to: 6.4.3
 * License: GPLv2 or later
 *
 * @package Easy Select and Share
 */

if ( ! defined( 'ABSPATH' ) ) {
	die();
}

define( 'ESAS_PLUGIN_URL', plugins_url( '', __FILE__ ) . '/' );
define( 'ESAS_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );

register_activation_hook( __FILE__, 'esas_create_log_table' );

if ( ! class_exists( 'WP_List_Table' ) ) {
	require_once ABSPATH . 'wp-admin/includes/class-wp-list-table.php';
}

add_action( 'plugins_loaded', 'esas_create_log_table' );

if ( ! function_exists( 'esas_create_log_table' ) ) {
	/**
	 * Create required tables.
	 */

	include_once ABSPATH . 'wp-admin/includes/plugin.php';

	// Deactive lite version plugin when pro is actived.
	if ( is_plugin_active( 'easy-select-and-share-pro/easy-select-and-share-pro.php' ) ) {

		if ( is_plugin_active( 'easy-select-and-share/easy-select-and-share.php' ) ) {

			deactivate_plugins( '/easy-select-and-share/easy-select-and-share.php' );
		}
	}
	/**
	 * Create Log Table.
	 */
	function esas_create_log_table() {
		global $wpdb;
		include_once ABSPATH . 'wp-admin/includes/upgrade.php';
		$table_name = $wpdb->prefix . 'sas_log';
		$sql        = "CREATE TABLE $table_name (
			id int(10) unsigned NOT NULL AUTO_INCREMENT,
			share_content varchar(1000) NOT NULL,
			social_media varchar(255) NOT NULL,
			post_id int(18) NOT NULL,
			post_type varchar(255) NOT NULL,
			post_name varchar(255) NOT NULL,
			share_date datetime,
			PRIMARY KEY  (id)
		) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
		dbDelta( $sql );
	}
}

require_once ESAS_PLUGIN_DIR . 'admin/class-esasadminedit.php';
require_once 'class-easyselectandshare.php';

